%% Initialization variables
clear all; clc;close all;
%Upper and lower border of voltage range
V_min_next = 3;
V_max_next = 4;
%voltage step
min_step_next =0.05;
%bit range of the data
bit_range = 0:1:255;
%Number of frames per sample
frames = 5;

%location of the files
location1 ='C:\ALL\School\MQP\PZ mapping\Accuracy test 1 020609\data 020609 1\IMG_0001_';
location2 ='C:\ALL\School\MQP\PZ mapping\Accuracy test 1 020609\data 020609 2\IMG_0001_';
location3 ='C:\ALL\School\MQP\PZ mapping\Accuracy test 1 020609\data 020609 3\IMG_0001_';
location4 ='C:\ALL\School\MQP\PZ mapping\Accuracy test 1 020609\data 020609 4\IMG_0001_';
location5 ='C:\ALL\School\MQP\PZ mapping\Accuracy test 1 020609\data 020609 5\IMG_0001_';
location6 ='C:\ALL\School\MQP\PZ mapping\Accuracy test 1 020609\data 020609 6\IMG_0001_';
location7 ='C:\ALL\School\MQP\PZ mapping\Accuracy test 1 020609\data 020609 7\IMG_0001_';


location=location1;

%minimum for the absolute value of the denominator in the cosine formula
cos_min = 0.01;

%iterator for the names of the files
name=0;
%max number of digits for the naming of the files
max_name = 4;

raw_line_voltage_result = 0;
raw_mean_voltage_result = 0;


%overall parameters for the iterations
min_step_absolute = 0.05;
step_change_factor = 2;
lower_limit = 0.9;
upper_limit=1.1;
continue_flag = 1;
reply = 'N';

%% Interate
while(reply ~= 'Y')
    reply = input('Do you want to start calibration? Y/N [Y]: ', 's');
    
    %default answer is Y
    if isempty(reply)
        reply = 'Y';
    end
    %stop if N
    if (reply == 'N')
        continue_flag=0;
        fprintf('\n   Calibration algorithm stopped!   \n');

        return;
    end
end

while (continue_flag==1)
     fprintf('\n   Calculating.....   \n');
    Iterate_042809_1;
    
    if (min_step_next<= min_step_absolute)
        fprintf('\n   The algorithm has converged to a final value   \n');
        fprintf(' Line: %g \n', raw_line_voltage_result);
        fprintf(' Line _1: %g \n', raw_line_voltage_result_1);
        fprintf(' Mean: %g \n', raw_mean_voltage_result);
        fprintf(' Mean_1:%g \n', raw_mean_voltage_result_1);
        continue_flag=0;
        return;
    else
       fprintf('\n Current iteration finished\n'); 
       fprintf('\n Current results: \n'); 
       fprintf(' Line: %g \n', raw_line_voltage_result);
       fprintf(' Line_1: %g \n', raw_line_voltage_result_1);
       fprintf(' Mean: %g \n', raw_mean_voltage_result);
       fprintf(' Mean_1: %g \n', raw_mean_voltage_result_1);
       
        reply = input('Do you want to continue calibration? Y/N [Y]: ', 's');
        %default answer is Y
        if isempty(reply)
          reply = 'Y';
        end
        
        %stop if N
        if (reply == 'N')
          continue_flag=0;
          fprintf('\n   Calibration algorithm stopped!   \n');
         return;
        end
        
        %continue if Y
        if (reply == 'Y')
          continue_flag=1;
          fprintf('\n Use the following parameters for next iteration: \n');
          fprintf(' Vmin: %g \n', V_min_next);
          fprintf(' Vmax: %g \n', V_max_next);
          fprintf(' Step: %g \n', min_step_next);
          
          reply = input('Ready to continue? Y/N [Y]: ', 's');
          %default answer is Y
          if isempty(reply)
             reply = 'Y';
          end
          %stop if N
          if (reply == 'N')
            continue_flag=0;
            fprintf('\n   Calibration algorithm stopped!   \n');
            return;
          end
          
        end 
    end
    
end

